const { IS_DEBUG } = require('../../config/env.config')

const logMap = {
  trace: 'color: lightseagreen',
  log: 'color: lightseagreen',
  warn: 'color: goldenrod',
  error: 'color: red',
}

export default class Logger {
  constructor(namespace) {
    this.namespace = namespace
  }

  static options = {
    // namespace: false
  }

  static config(options = {}) {
    Object.assign(Logger.options, options)
  }
}

Object.entries(logMap).forEach(([method, color]) => {
  Logger.prototype[method] = (...args) => {
    // 如果不是开发模式，或者明确定指该命名空间不开启日志打印
    // 则打印方法设置为空函数
    if (!IS_DEBUG || Logger.options[this.namespace] === false) {
      return
    }

    const exp = `%c[${this.namespace}]:`
    args.unshift(exp, color)
    /* eslint-disable no-console */
    console[method](...args)
    /* eslint-enable */
  }
})
